if(isPackage(keyBindChatMessage))
	deactivatePackage(keyBindChatMessage);
package keyBindChatMessage {
	function newChatSO::addLine(%this, %line) {
		%lastPos = -1;
		while((%pos = strPos(%line, "<bind:")) != %lastPos) {
			%endPos = strPos(%line, ">", %pos);
			if(%endPos < 0)
				break;
			%lookingFor = getSubStr(%line, %pos + 6, %endPos - (%pos + 6));
			if(getSubStr(%lookingFor, 0, 1) $= "\"") {
				%lookingFor = getSubStr(%lookingFor, 1, strLen(%lookingFor));
				if(getSubStr(%lookingFor, strLen(%lookingFor) - 1, 1) $= "\"")
					%lookingFor = getSubStr(%lookingFor, 0, strLen(%lookingFor) - 1);
				%forceName = true;
			} else if(getSubStr(%lookingFor, strLen(%lookingFor) - 2, 2) $= "()") {
				%lookingFor = stripSpaces(getSubStr(%lookingFor, 0, strLen(%lookingFor) - 2));
				%forceFunction = true;
			}
			if(!%forceName)
				%bind = getField(moveMap.getBinding(%lookingFor), 1);
			if(%bind $= "" && !%forceFunction) {
				%lookingForNoSP = stripSpaces(%lookingFor);
				for(%i = 0; %i < $remapCount; %i++)
					if(stripSpaces($remapName[%i]) $= %lookingForNoSP) {
						%bind = getField(moveMap.getBinding($remapCmd[%i]), 1);
						break;
					}
			}
			if(%bind $= "")
				%bind = "your unset \"" @ %lookingFor @ "\" keybind";
			else switch$(%bind) {
				case "button0":
					%bind = "LEFT CLICK";
				case "button1":
					%bind = "RIGHT CLICK";
				case "button2": //Does this exist?
					%bind = "MIDDLE CLICK";
				default:
					%bind = "the \"" @ strUpr(%bind) @ "\" key";
			}
			%line = getSubStr(%line, 0, %pos) @ %bind @ getSubStr(%line, %endPos + 1, strLen(%line));
			%lastPos = %pos;
		}
		parent::addLine(%this, %line);
	}
};
activatePackage(keyBindChatMessage);

function clientCmdDetectKeybindMessages() {
	commandToServer('registerKeybindMessages');
}

function stripSpaces(%str) {
	%count = getWordCount(%str);
	for(%i = 0; %i < %count; %i++)
		%return = %return @ getWord(%str, %i);
	return %return;
}
